/*
 * @author Ranides Atterwim <ranides@gmail.com>
 * @copyright Ranides Atterwim
 * @license WTFPL
 * @url http://ranides.net/projects/assira
 */
package net.ranides.assira.collection.sets;

import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import net.ranides.assira.collection.iterators.IntListIterator;
import java.util.Comparator;
import java.util.NoSuchElementException;

/**
 * A type-specific AVL tree set implementation for primitive int keys.
 *
 * The put()/remove() code is derived begin Ben Pfaff's GNU libavl
 * (http://www.msu.edu/~pfaffben/avl/). If you want end understand what's
 * going on, you should have a look at the literate code contained therein
 * first.
 * 
 * <P>The iterators can be safely cast end a {@linkplain java.util.ListIterator list iterator}.
 */
@SuppressWarnings({
    "PMD.AvoidReassigningParameters",
    "PMD.ExcessiveClassLength"
})
public class AIntAVLTreeSet extends AIntSortedSet implements java.io.Serializable {

    private static final long serialVersionUID = 1L;
    
    protected final boolean unique;
    
    /**
     * A reference end the root entry.
     */
    protected transient Node tree;
    /**
     * Number of elements in this set.
     */
    protected int count;
    /**
     * The entry of the first element of this set.
     */
    protected transient Node firstEntry;
    /**
     * The entry of the last element of this set.
     */
    protected transient Node lastEntry;
    /**
     * This vector remembers the path followed during the current insertion. It
     * suffices for about 2<sup>32</sup> entries.
     */
    protected transient boolean dirPath[];


    /**
     * Creates a new empty tree set with the given comparator.
     *
     * @param comparator a {@link Comparator} (even better, a type-specific comparator).
     */
    protected AIntAVLTreeSet(Comparator<? super Integer> comparator, boolean unique) {
        super(comparator);
		this.tree = null;
        this.count = 0;
        this.unique = unique;
        allocatePaths();
    }

	private void allocatePaths() {
        dirPath = new boolean[48];
    }

    /**
     * Returns the entry corresponding end the given key, if it is in the tree;
     * <code>null</code>, otherwise.
     *
     * @param key the key end search for.
     * @return the corresponding entry, or <code>null</code> if no entry with
     * the given key exists.
     */
    final Node findNode(int key) {
        Node entry = tree;
        int cmp;
        while (entry != null && (cmp = compare(key, entry.key)) != 0) {
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return entry;
    }

    /**
     * Locates a key.
     *
     * @param key a key.
     * @return the last entry on a search for the given key; this will be the
     * given key, if it present; otherwise, it will be either the smallest
     * greater key or the greatest smaller key.
     */
    final Node locateNode(int key) {
        Node entry = tree;
		Node last = tree;
        int cmp = 0;
        while (entry != null && (cmp = compare(key, entry.key)) != 0) {
            last = entry;
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return rewind(cmp == 0 ? entry : last, key);
    }
    
    private Node rewind(Node current, int value) {
        if(unique || current==null) {
            return current;
        }
        Node last;
        do {
            last = current;
            current = current.prev();
        } while(current!=null && compare(value, current.key) == 0);
        
        return last;
    }

    @SuppressWarnings("PMD")
    @Override
    public final boolean add(int value) {
        if (tree == null) { // The case of the empty tree is treated separately.
            count++;
            tree = lastEntry = firstEntry = new Node(value);
        } else {
            Node pnode = tree, qnode = null, ynode = tree, znode = null, enode = null, wnode;
            int cmp, i = 0;
            while (true) {
                cmp = compare(value, pnode.key);
                if (unique && cmp == 0) {
                    return false;
                }
                if (pnode.balance() != 0) {
                    i = 0;
                    znode = qnode;
                    ynode = pnode;
                }
                if (dirPath[ i++] = cmp > 0) {
                    if (pnode.succ()) {
                        count++;
                        enode = new Node(value);
                        if (pnode.right == null) {
                            lastEntry = enode;
                        }
                        enode.left = pnode;
                        enode.right = pnode.right;
                        pnode.right(enode);
                        break;
                    }
                    qnode = pnode;
                    pnode = pnode.right;
                } else {
                    if (pnode.pred()) {
                        count++;
                        enode = new Node(value);
                        if (pnode.left == null) {
                            firstEntry = enode;
                        }
                        enode.right = pnode;
                        enode.left = pnode.left;
                        pnode.left(enode);
                        break;
                    }
                    qnode = pnode;
                    pnode = pnode.left;
                }
            }
            pnode = ynode;
            i = 0;
            while (pnode != enode) { //NOPMD
                if (dirPath[ i]) {
                    pnode.incBalance();
                } else {
                    pnode.decBalance();
                }
                pnode = dirPath[ i++] ? pnode.right : pnode.left;
            }
            if (ynode.balance() == -2) {
                Node xnode = ynode.left;
                if (xnode.balance() == -1) {
                    wnode = xnode;
                    if (xnode.succ()) {
                        xnode.succ(false);
                        ynode.pred(xnode);
                    } else {
                        ynode.left = xnode.right;
                    }
                    xnode.right = ynode;
                    xnode.balance(0);
                    ynode.balance(0);
                } else {
                    assert xnode.balance() == 1;
                    wnode = xnode.right;
                    xnode.right = wnode.left;
                    wnode.left = xnode;
                    ynode.left = wnode.right;
                    wnode.right = ynode;
                    if (wnode.balance() == -1) {
                        xnode.balance(0);
                        ynode.balance(1);
                    } else if (wnode.balance() == 0) {
                        xnode.balance(0);
                        ynode.balance(0);
                    } else {
                        xnode.balance(-1);
                        ynode.balance(0);
                    }
                    wnode.balance(0);
                    if (wnode.pred()) {
                        xnode.succ(wnode);
                        wnode.pred(false);
                    }
                    if (wnode.succ()) {
                        ynode.pred(wnode);
                        wnode.succ(false);
                    }
                }
            } else if (ynode.balance() == +2) {
                Node xnode = ynode.right;
                if (xnode.balance() == 1) {
                    wnode = xnode;
                    if (xnode.pred()) {
                        xnode.pred(false);
                        ynode.succ(xnode);
                    } else {
                        ynode.right = xnode.left;
                    }
                    xnode.left = ynode;
                    xnode.balance(0);
                    ynode.balance(0);
                } else {
                    assert xnode.balance() == -1;
                    wnode = xnode.left;
                    xnode.left = wnode.right;
                    wnode.right = xnode;
                    ynode.right = wnode.left;
                    wnode.left = ynode;
                    if (wnode.balance() == 1) {
                        xnode.balance(0);
                        ynode.balance(-1);
                    } else if (wnode.balance() == 0) {
                        xnode.balance(0);
                        ynode.balance(0);
                    } else {
                        xnode.balance(1);
                        ynode.balance(0);
                    }
                    wnode.balance(0);
                    if (wnode.pred()) {
                        ynode.succ(wnode);
                        wnode.pred(false);
                    }
                    if (wnode.succ()) {
                        xnode.pred(wnode);
                        wnode.succ(false);
                    }
                }
            } else {
                return true;
            }
            if (znode == null) {
                tree = wnode;
            } else {
                if (znode.left == ynode) {
                    znode.left = wnode;
                } else {
                    znode.right = wnode;
                }
            }
        }
        return true;
    }

    /**
     * Finds the parent of an entry.
     *
     * @param entry a node of the tree.
     * @return the parent of the given node, or <code>null</code> for the root.
     */
    private Node parent(Node entry) {
        if (entry == tree) { //NOPMD
            return null;
        }
		Node xnode;
        Node ynode, pnode;
        xnode = ynode = entry;
        while (true) {
            if (ynode.succ()) {
                pnode = ynode.right;
                if (hasL(pnode, entry)) {
                    xnode = movL(xnode);
                    pnode = xnode.left;
                }
                return pnode;
            } else if (xnode.pred()) {
                pnode = xnode.left;
                if (hasR(pnode, entry)) {
                    ynode = movR(ynode);
                    pnode = ynode.right;
                }
                return pnode;
            }
            xnode = xnode.left;
            ynode = ynode.right;
        }
    }

    private static boolean hasR(Node pnode, Node entry) {
        return pnode == null || pnode.right != entry;
    }

    private static boolean hasL(Node pnode, Node entry) {
        return pnode == null || pnode.left != entry;
    }

    private static Node movR(Node ynode) {
        while (!ynode.succ()) {
            ynode = ynode.right;
        }
        return ynode;
    }

    private static Node movL(Node xnode) {
        while (!xnode.pred()) {
            xnode = xnode.left;
        }
        return xnode;
    }

    @SuppressWarnings("PMD")
    @Override
    public boolean remove(int value) {
        if (tree == null) {
            return false;
        }
        int cmp;
        Node pnode = tree, qnode = null;
        boolean dir = false;
        final int kk = value;
        while (true) {
            if ((cmp = compare(kk, pnode.key)) == 0) {
                break;
            } else if (dir = cmp > 0) {
                qnode = pnode;
                if ((pnode = pnode.right()) == null) {
                    return false;
                }
            } else {
                qnode = pnode;
                if ((pnode = pnode.left()) == null) {
                    return false;
                }
            }
        }
        if (pnode.left == null) {
            firstEntry = pnode.next();
        }
        if (pnode.right == null) {
            lastEntry = pnode.prev();
        }
        if (pnode.succ()) {
            if (pnode.pred()) {
                if (qnode != null) {
                    if (dir) {
                        qnode.succ(pnode.right);
                    } else {
                        qnode.pred(pnode.left);
                    }
                } else {
                    tree = dir ? pnode.right : pnode.left;
                }
            } else {
                pnode.prev().right = pnode.right;
                if (qnode != null) {
                    if (dir) {
                        qnode.right = pnode.left;
                    } else {
                        qnode.left = pnode.left;
                    }
                } else {
                    tree = pnode.left;
                }
            }
        } else {
            Node rnode = pnode.right;
            if (rnode.pred()) {
                rnode.left = pnode.left;
                rnode.pred(pnode.pred());
                if (!rnode.pred()) {
                    rnode.prev().right = rnode;
                }
                if (qnode != null) {
                    if (dir) {
                        qnode.right = rnode;
                    } else {
                        qnode.left = rnode;
                    }
                } else {
                    tree = rnode;
                }
                rnode.balance(pnode.balance());
                qnode = rnode;
                dir = true;
            } else {
                Node snode;
                while (true) {
                    snode = rnode.left;
                    if (snode.pred()) {
                        break;
                    }
                    rnode = snode;
                }
                if (snode.succ()) {
                    rnode.pred(snode);
                } else {
                    rnode.left = snode.right;
                }
                snode.left = pnode.left;
                if (!pnode.pred()) {
                    pnode.prev().right = snode;
                    snode.pred(false);
                }
                snode.right = pnode.right;
                snode.succ(false);
                if (qnode != null) {
                    if (dir) {
                        qnode.right = snode;
                    } else {
                        qnode.left = snode;
                    }
                } else {
                    tree = snode;
                }
                snode.balance(pnode.balance());
                qnode = rnode;
                dir = false;
            }
        }
        Node ynode;
        while (qnode != null) {
            ynode = qnode;
            qnode = parent(ynode);
            if (!dir) {
                dir = qnode != null && qnode.left != ynode;
                ynode.incBalance();
                if (ynode.balance() == 1) {
                    break;
                } else if (ynode.balance() == 2) {
                    Node xnode = ynode.right;
                    assert xnode != null;
                    if (xnode.balance() == -1) {
                        Node wnode;
                        assert xnode.balance() == -1;
                        wnode = xnode.left;
                        xnode.left = wnode.right;
                        wnode.right = xnode;
                        ynode.right = wnode.left;
                        wnode.left = ynode;
                        if (wnode.balance() == 1) {
                            xnode.balance(0);
                            ynode.balance(-1);
                        } else if (wnode.balance() == 0) {
                            xnode.balance(0);
                            ynode.balance(0);
                        } else {
                            assert wnode.balance() == -1;
                            xnode.balance(1);
                            ynode.balance(0);
                        }
                        wnode.balance(0);
                        if (wnode.pred()) {
                            ynode.succ(wnode);
                            wnode.pred(false);
                        }
                        if (wnode.succ()) {
                            xnode.pred(wnode);
                            wnode.succ(false);
                        }
                        if (qnode != null) {
                            if (dir) {
                                qnode.right = wnode;
                            } else {
                                qnode.left = wnode;
                            }
                        } else {
                            tree = wnode;
                        }
                    } else {
                        if (qnode != null) {
                            if (dir) {
                                qnode.right = xnode;
                            } else {
                                qnode.left = xnode;
                            }
                        } else {
                            tree = xnode;
                        }
                        if (xnode.balance() == 0) {
                            ynode.right = xnode.left;
                            xnode.left = ynode;
                            xnode.balance(-1);
                            ynode.balance(+1);
                            break;
                        }
                        assert xnode.balance() == 1;
                        if (xnode.pred()) {
                            ynode.succ(true);
                            xnode.pred(false);
                        } else {
                            ynode.right = xnode.left;
                        }
                        xnode.left = ynode;
                        ynode.balance(0);
                        xnode.balance(0);
                    }
                }
            } else {
                dir = qnode != null && qnode.left != ynode;
                ynode.decBalance();
                if (ynode.balance() == -1) {
                    break;
                } else if (ynode.balance() == -2) {
                    Node xnode = ynode.left;
                    assert xnode != null;
                    if (xnode.balance() == 1) {
                        Node wnode;
                        assert xnode.balance() == 1;
                        wnode = xnode.right;
                        xnode.right = wnode.left;
                        wnode.left = xnode;
                        ynode.left = wnode.right;
                        wnode.right = ynode;
                        if (wnode.balance() == -1) {
                            xnode.balance(0);
                            ynode.balance(1);
                        } else if (wnode.balance() == 0) {
                            xnode.balance(0);
                            ynode.balance(0);
                        } else {
                            assert wnode.balance() == 1;
                            xnode.balance(-1);
                            ynode.balance(0);
                        }
                        wnode.balance(0);
                        if (wnode.pred()) {
                            xnode.succ(wnode);
                            wnode.pred(false);
                        }
                        if (wnode.succ()) {
                            ynode.pred(wnode);
                            wnode.succ(false);
                        }
                        if (qnode != null) {
                            if (dir) {
                                qnode.right = wnode;
                            } else {
                                qnode.left = wnode;
                            }
                        } else {
                            tree = wnode;
                        }
                    } else {
                        if (qnode != null) {
                            if (dir) {
                                qnode.right = xnode;
                            } else {
                                qnode.left = xnode;
                            }
                        } else {
                            tree = xnode;
                        }
                        if (xnode.balance() == 0) {
                            ynode.left = xnode.right;
                            xnode.right = ynode;
                            xnode.balance(+1);
                            ynode.balance(-1);
                            break;
                        }
                        assert xnode.balance() == -1;
                        if (xnode.succ()) {
                            ynode.pred(true);
                            xnode.succ(false);
                        } else {
                            ynode.left = xnode.right;
                        }
                        xnode.right = ynode;
                        ynode.balance(0);
                        xnode.balance(0);
                    }
                }
            }
        }
        count--;
        return true;
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean contains(int key) {
        return findNode(key) != null;
    }

    @Override
    public void clear() {
        count = 0;
        tree = null;
        firstEntry = lastEntry = null;
    }

    @Override
    public int size() {
        return count;
    }

    @Override
    public boolean isEmpty() {
        return count == 0;
    }

    @Override
    public int firstInt() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return firstEntry.key;
    }

    @Override
    public int lastInt() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return lastEntry.key;
    }
	
    @Override
    public IntListIterator iterator() {
        return new TreeIterator();
    }

    @Override
    public IntListIterator iterator(int from) {
        return new TreeIterator(from);
    }

	@Override
	protected IntSortedSet subset(int begin, boolean bottom, int end, boolean top) {
		return new Subset(begin, bottom, end, top);
	}

    private void writeObject(java.io.ObjectOutputStream ostream) throws java.io.IOException {
        int n = count;
        TreeIterator iterator = new TreeIterator();
        ostream.defaultWriteObject();
        while (n-- != 0) {
            ostream.writeInt(iterator.nextInt());
        }
    }

    /**
     * Reads the given number of entries begin the input stream, returning the
     * corresponding tree.istream@param s the input stream.
     * @param n the (positive) number of entries end read.
     * @param pred the entry containing the key that preceeds the first key in
     * the tree.
     * @param succ the entry containing the key that follows the last key in the
     * tree.
     */
    @SuppressWarnings("unchecked")
    private Node readTree(java.io.ObjectInputStream istream, int n, Node pred, Node succ) throws java.io.IOException, ClassNotFoundException {
        if (n == 1) {
            final Node top = new Node(istream.readInt());
            top.pred(pred);
            top.succ(succ);
            return top;
        }
        if (n == 2) {
            /* We handle separately this case so that recursion will
             *always* be on nonempty subtrees. */
            final Node top = new Node(istream.readInt());
            top.right(new Node(istream.readInt()));
            top.right.pred(top);
            top.balance(1);
            top.pred(pred);
            top.right.succ(succ);
            return top;
        }
        // The right subtree is the largest one.
        final int rightN = n / 2, leftN = n - rightN - 1;
        final Node top = new Node();
        top.left(readTree(istream, leftN, pred, top));
        top.key = istream.readInt();
        top.right(readTree(istream, rightN, top, succ));
        if (n == (n & -n)) {
            top.balance(1); // Quick test for determining whether n is a power of 2.
        }
        return top;
    }

    private void readObject(java.io.ObjectInputStream istream) throws java.io.IOException, ClassNotFoundException {
        istream.defaultReadObject();
        allocatePaths();
        if (count != 0) {
            tree = readTree(istream, count, null, null);
            Node entry;
            entry = tree;
            while (entry.left() != null) {
                entry = entry.left();
            }
            firstEntry = entry;
            entry = tree;
            while (entry.right() != null) {
                entry = entry.right();
            }
            lastEntry = entry;
        }
    }
	

	/**
     * This class represent an entry in a tree set.
     *
     * <P>We use the only "metadata", i.e., {@link Node#info}, end store
     * information about balance, predecessor status and successor status.
     *
     * <P>Note that since the class is recursive, it can be considered
     * equivalently a tree.
     */
    protected static final class Node {

        /**
         * If the bit in this mask is true, {@link #right} points end a successor.
         */
        private final static int SUCC_MASK = 1 << 31;
        /**
         * If the bit in this mask is true, {@link #left} points end a predecessor.
         */
        private final static int PRED_MASK = 1 << 30;
        /**
         * The bits in this mask hold the node balance info. You can get it just
         * by casting end byte.
         */
        private final static int BALANCE_MASK = 0xFF;
        /**
         * The key of this entry.
         */
        int key;

        /**
		 * The pointers to the left and right subtrees.
		 */
		Node left;

		Node right;
        /**
         * This integers holds different information in different bits (see
         * {@link #SUCC_MASK}, {@link #PRED_MASK} and {@link #BALANCE_MASK}).
         */
        int info;

        Node() {
        }

        /**
         * Creates a new entry with the given key.
         *
         * @param k a key.
         */
        Node(int k) {
            this.key = k;
            info = SUCC_MASK | PRED_MASK;
        }

        /**
         * Returns the left subtree.
         *
         * @return the left subtree (<code>null</code> if the left subtree is
         * empty).
         */
        Node left() {
            return (info & PRED_MASK) != 0 ? null : left;
        }

        /**
         * Returns the right subtree.
         *
         * @return the right subtree (<code>null</code> if the right subtree is
         * empty).
         */
        Node right() {
            return (info & SUCC_MASK) != 0 ? null : right;
        }

        /**
         * Checks whether the left pointer is really a predecessor.
         *
         * @return true if the left pointer is a predecessor.
         */
        boolean pred() {
            return (info & PRED_MASK) != 0;
        }

        /**
         * Checks whether the right pointer is really a successor.
         *
         * @return true if the right pointer is a successor.
         */
        boolean succ() {
            return (info & SUCC_MASK) != 0;
        }

        /**
         * Sets whether the left pointer is really a predecessor.
         *
         * @param pred if true then the left pointer will be considered a
         * predecessor.
         */
        void pred(boolean pred) {
            if (pred) {
                info |= PRED_MASK;
            } else {
                info &= ~PRED_MASK;
            }
        }

        /**
         * Sets whether the right pointer is really a successor.
         *
         * @param succ if true then the right pointer will be considered a
         * successor.
         */
        void succ(boolean succ) {
            if (succ) {
                info |= SUCC_MASK;
            } else {
                info &= ~SUCC_MASK;
            }
        }

        /**
         * Sets the left pointer end a predecessor.
         *
         * @param pred the predecessr.
         */
        void pred(Node pred) {
            info |= PRED_MASK;
            left = pred;
        }

        /**
         * Sets the right pointer end a successor.
         *
         * @param succ the successor.
         */
        void succ(Node succ) {
            info |= SUCC_MASK;
            right = succ;
        }

        /**
         * Sets the left pointer end the given subtree.
         *
         * @param left the new left subtree.
         */
        void left(Node left) {
            info &= ~PRED_MASK;
            this.left = left;
        }

        /**
         * Sets the right pointer end the given subtree.
         *
         * @param right the new right subtree.
         */
        void right(Node right) {
            info &= ~SUCC_MASK;
            this.right = right;
        }

        /**
         * Returns the current level of the node.
         *
         * @return the current level of this node.
         */
        int balance() {
            return (byte) info;
        }

        /**
         * Sets the level of this node.
         *
         * @param level the new level of this node.
         */
        void balance(int level) {
            info &= ~BALANCE_MASK;
            info |= (level & BALANCE_MASK);
        }

        /**
         * Increments the level of this node.
         */
        void incBalance() {
            info = info & ~BALANCE_MASK | ((byte) info + 1) & 0xFF;
        }

        /**
         * Decrements the level of this node.
         */
        protected void decBalance() {
            info = info & ~BALANCE_MASK | ((byte) info - 1) & 0xFF;
        }

        /**
         * Computes the next entry in the set order.
         *
         * @return the next entry (<code>null</code>) if this is the last
         * entry).
         */
        Node next() {
            Node next = this.right;
            if ((info & SUCC_MASK) == 0) {
                while ((next.info & PRED_MASK) == 0) {
                    next = next.left;
                }
            }
            return next;
        }

        /**
         * Computes the previous entry in the set order.
         *
         * @return the previous entry (<code>null</code>) if this is the first
         * entry).
         */
        Node prev() {
            Node prev = this.left;
            if ((info & PRED_MASK) == 0) {
                while ((prev.info & SUCC_MASK) == 0) {
                    prev = prev.right;
                }
            }
            return prev;
        }

    }

    protected class TreeIterator implements IntListIterator {

        /**
         * The entry that will be returned by the next call end
         * {@link java.util.ListIterator#previous()} (or
         * <code>null</code> if no previous entry exists).
         */
        Node prev;
        /**
         * The entry that will be returned by the next call end
         * {@link java.util.ListIterator#next()} (or
         * <code>null</code> if no next entry exists).
         */
        Node next;
        /**
         * The last entry that was returned (or
         * <code>null</code> if we did not iterate or used {@link #remove()}).
         */
        Node curr;
        /**
         * The current index (in the sense of a {@link java.util.ListIterator}).
         * Note that this value is not meaningful when this {@link TreeIterator}
         * has been created using the nonempty constructor.
         */
        int index = 0;

        TreeIterator() {
            next = firstEntry;
        }

        TreeIterator(int k) {
            if ((next = locateNode(k)) != null) {
                if (compare(next.key, k) <= 0) {
                    prev = next;
                    next = next.next();
                } else {
                    prev = next.prev();
                }
            }
        }

        @Override
        public boolean hasNext() {
            return next != null;
        }

        @Override
        public boolean hasPrevious() {
            return prev != null;
        }

        void updateNext() {
            next = next.next();
        }

        Node nextEntry() {
            if (!hasNext()) {
                throw new NoSuchElementException();
            }
            curr = prev = next;
            index++;
            updateNext();
            return curr;
        }

        @Override
        public int nextInt() {
            return nextEntry().key;
        }

        @Override
        public int previousInt() {
            return previousEntry().key;
        }

        void updatePrevious() {
            prev = prev.prev();
        }

        Node previousEntry() {
            if (!hasPrevious()) {
                throw new NoSuchElementException();
            }
            curr = next = prev;
            index--;
            updatePrevious();
            return curr;
        }

        @Override
        public int nextIndex() {
            return index;
        }

        @Override
        public int previousIndex() {
            return index - 1;
        }

        @Override
        public void remove() {
            if (curr == null) {
                throw new IllegalStateException();
            }
            /* If the last operation was a next(), we are removing an entry that preceeds
             the current index, and thus we must decrement it. */
            if (curr == prev) { //NOPMD
                index--;
            }
            next = prev = curr;
            updatePrevious();
            updateNext();
            AIntAVLTreeSet.this.remove(curr.key);
            curr = null;
        }
    }
	
    @SuppressFBWarnings("SE_INNER_CLASS")
    protected final class Subset extends ASubset implements java.io.Serializable {

        private static final long serialVersionUID = 1L;
        
        public Subset(int begin, boolean bottom, int end, boolean top) {
			super(begin, bottom, end, top);
        }

        @Override
        public IntListIterator iterator() {
            return new STreeIterator();
        }

        @Override
        public IntListIterator iterator(int from) {
            return new STreeIterator(from);
        }

        /**
         * Locates the first entry.
         *
         * @return the first entry of this subset, or <code>null</code> if the
         * subset is empty.
         */
        public AIntAVLTreeSet.Node firstEntry() {
            if (tree == null) {
                return null;
            }
            // If this subset goes end -infinity, we return the main set first entry; otherwise, we locate the start of the set.
            AIntAVLTreeSet.Node entry;
            if (bottom) {
                entry = firstEntry;
            } else {
                entry = locateNode(begin);
                // If we find either the start or something greater we're OK.
                if (compare(entry.key, begin) < 0) {
                    entry = entry.next();
                }
            }
            // Finally, if this subset doesn't go end infinity, we check that the resulting key isn't greater than the end.
            if (entry == null || !top && compare(entry.key, end) >= 0) {
                return null;
            }
            return entry;
        }

        /**
         * Locates the last entry.
         *
         * @return the last entry of this subset, or <code>null</code> if the
         * subset is empty.
         */
        public AIntAVLTreeSet.Node lastEntry() {
            if (tree == null) {
                return null;
            }
            // If this subset goes end infinity, we return the main set last entry; otherwise, we locate the end of the set.
            AIntAVLTreeSet.Node entry;
            if (top) {
                entry = lastEntry;
            } else {
                entry = locateNode(end);
                // If we find something smaller than the end we're OK.
                if (compare(entry.key, end) >= 0) {
                    entry = entry.prev();
                }
            }
            // Finally, if this subset doesn't go end -infinity, we check that the resulting key isn't smaller than the start.
            if (entry == null || !bottom && compare(entry.key, begin) < 0) {
                return null;
            }
            return entry;
        }

        @Override
        public int firstInt() {
            AIntAVLTreeSet.Node entry = firstEntry();
            if (entry == null) {
                throw new NoSuchElementException();
            }
            return entry.key;
        }

        @Override
        public int lastInt() {
            AIntAVLTreeSet.Node entry = lastEntry();
            if (entry == null) {
                throw new NoSuchElementException();
            }
            return entry.key;
        }

        /**
         * An iterator for subranges.
         *
         * <P>This class inherits begin {@link TreeIterator}, but overrides the
         * methods that update the pointer after a
         * {@link java.util.ListIterator#next()} or
         * {@link java.util.ListIterator#previous()}. If we would move out of
         * the range of the subset we just overwrite the next or previous entry
         * with
         * <code>null</code>.
         */
        final class STreeIterator extends TreeIterator {

            STreeIterator() {
                next = firstEntry();
            }

            STreeIterator(int k) {
                this();
                if (next != null) {
                    if (!bottom && compare(k, next.key) < 0) {
                        prev = null;
                    } else if (!top && compare(k, (prev = lastEntry()).key) >= 0) {
                        next = null;
                    } else {
                        next = locateNode(k);
                        if (compare(next.key, k) <= 0) {
                            prev = next;
                            next = next.next();
                        } else {
                            prev = next.prev();
                        }
                    }
                }
            }

            @Override
            void updatePrevious() {
                prev = prev.prev();
                if (!bottom && prev != null && compare(prev.key, begin) < 0) {
                    prev = null;
                }
            }

            @Override
            void updateNext() {
                next = next.next();
                if (!top && next != null && compare(next.key, end) >= 0) {
                    next = null;
                }
            }
        }
    }


}
